<?php
// import the JPlugin class
jimport('joomla.event.plugin');

global $mainframe;

class plgPayperDownloadplusRemository extends JPlugin
{
	public function __construct(&$subject, $config = array())
    {
        parent::__construct($subject);
		// load the language file
		$lang = &JFactory::getLanguage();
		$lang->load('plg_payperdownloadplus_remository', JPATH_SITE.DS.'administrator');
	}

	function onIsActive(&$plugins)
	{
		$version = new JVersion;
		if($version->RELEASE >= "1.6")
			return false;
		$component = JComponentHelper::getComponent('com_remository', true);
		if($component->enabled)
		{
			jimport('joomla.filesystem.file');
			$image = "";
			if(JFile::exists(JPATH_ROOT . DS . 'plugins' . DS . 'payperdownloadplus' . DS . 'header.jpg'))
				$image = "plugins/payperdownloadplus/header.jpg";
				
			$plugins[] = array("name" => "Remository", "description" => JText::_("Remository file"), 
				"image" => $image);
		}
	}
	
	function reorderCats(&$cats_ordered, $cats, $parent_id, $depth)
	{
		$count = count($cats);
		for($i = 0; $i < $count; $i++)
		{
			$cat = $cats[$i];
			if($cat->parentid == $parent_id)
			{
				$cat->depth = $depth;
				$cats_ordered[] = $cat;
				$this->reorderCats($cats_ordered, $cats, $cat->id, $depth + 1);
			}
		}
	}
	
	function getRemositoryCategories()
	{
		$db =& JFactory::getDBO();
		$db->setQuery('SELECT id, name, parentid FROM #__downloads_containers');
		$cats = $db->loadObjectList();
		$cats_ordered = array();
		$this->reorderCats($cats_ordered, $cats, 0, 0);
		return $cats_ordered;
	}
	
	function getFiles($cat_id)
	{
		$db =& JFactory::getDBO();
		$db->setQuery('SELECT id, filetitle as title FROM #__downloads_files WHERE containerid = ' . (int)$cat_id);
		return $db->loadObjectList();
	}
	
	function onRenderConfig($pluginName, $resource)
	{
		if($pluginName == "Remository")
		{
			if($resource)
			{
				$file_id = $resource->resource_id;
				$category_id = $resource->resource_params;
				if($category_id)
					$files = $this->getFiles($category_id);
			}
			$uri = JURI::root();
			$scriptPath = "administrator/components/com_payperdownloadplus/js/";
			JHTML::script('ajax_source.js', $scriptPath, false);
			$version = new JVersion;
			if($version->RELEASE == "1.6")
				$plugin_path = "plugins/payperdownloadplus/remository/";
			else
				$plugin_path = "plugins/payperdownloadplus/";
			$scriptPath = $uri . $plugin_path;
			JHTML::script('remository_plugin.js', $scriptPath, false);
			$cats = $this->getRemositoryCategories();
			?>
			<tr>
			<td  width="100" align="right" class="key"><?php echo htmlspecialchars(JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_CATEGORY"));?></td>
			<td>
			<select id="remository_category" name="remository_category" onchange="remository_plugin_category_change();">
			<option value="0"><?php echo JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_ALL_CATEGORIES");?></option>
			<?php
			foreach($cats as $cat)
			{
				$space = '';
				for($i = 0; $i < $cat->depth; $i++)
					$space .= '&nbsp;&nbsp;&nbsp;&nbsp;';
				$selected = $cat->id == $category_id ? "selected":"";
				echo "<option value=\"" . htmlspecialchars($cat->id) . "\" $selected>" . $space . htmlspecialchars($cat->name) . "</option>";
			}
			?>
			</select>
			</td>
			</tr>
			<tr>
			<td  width="100" align="right" class="key"><?php echo htmlspecialchars(JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_DOWNLOAD"));?></td>
			<td>
			<select id="remository_file" name="remository_file">
			<option value="0"><?php echo JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_ALL_DOWNLOADS");?></option>
			<?php
			if($files)
			foreach($files as $file)
			{
				$selected = $file->id == $file_id ? "selected":"";
				echo "<option value=\"" . htmlspecialchars($file->id) . "\" $selected>" . htmlspecialchars($file->title) . "</option>";
			}
			?>
			</select>
			</td>
			</tr>
			<?php
		}
	}
	
	function onGetSaveData(&$resourceId, 
		$pluginName, &$resourceName, &$resourceParams, &$optionParameter,
		&$resourceDesc)
	{
		if($pluginName == "Remository")
		{
			$optionParameter = "com_remository";
			$resourceId = JRequest::getInt('remository_file');
			$categoryId = JRequest::getInt('remository_category');
			$db =& JFactory::getDBO();
			$query = "";
			$resourceDesc = JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_ALL_DOWNLOADS");
			if($resourceId)
			{
				$query = "SELECT id, filetitle as title FROM #__downloads_files WHERE id = " . $resourceId;
				$resourceDesc = JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_DOWNLOAD");
			}
			else if($categoryId)
			{
				$resourceId = -1;
				$query = "SELECT id, name as title FROM #__downloads_containers WHERE id = " . $categoryId;
				$resourceDesc = JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_CATEGORY");
			}
			else
			{
				$resourceId = -1;
			}
			$resourceName = JText::_("PAYPERDOWNLOADPLUS_REMOSITORY_PLUGIN_ALL_DOWNLOADS");
			if($query)
			{
				$db->setQuery($query);
				$resource = $db->loadObject();
				if($resource)
					$resourceName = $resource->title;
			}
			$resourceParams = $categoryId;
		}
	}
	
	
	function onValidateAccess($option, $resources, &$allowAccess, &$requiredLicenses, &$resourcesId)
	{
		if($option == 'com_remository')
		{
			$task = JRequest::getVar('func');
			if($task == 'startdown' || $task = 'download')
			{
				$requiredLicenses = array();
				$resourcesId = array();
				$download = JRequest::getInt('id', 0);
				
				foreach($resources as $resource)
				{
					if($resource->resource_id == $download)
					{
						if($resource->license_id)
						{
							if(array_search($resource->license_id, $requiredLicenses) === false)
								$requiredLicenses[] = $resource->license_id;
						}
						else
						{
							if(array_search($resource->resource_license_id, $resourcesId) === false)
								$resourcesId[] = $resource->resource_license_id;
						}
						$allowAccess = false;
					}
				}
				
				if(count($requiredLicenses) == 0 && count($resourcesId) == 0)
				{
					$db =& JFactory::getDBO();
					$db->setQuery("SELECT containerid FROM #__downloads_files WHERE id =" . (int)$download);
					$cats = $db->loadResultArray();
					if(count($cats) == 0)
						return;
					foreach($resources as $resource)
					{
						if($resource->resource_id == -1 && array_search($resource->resource_params, $cats) !== false)
						{
							if($resource->license_id)
							{	
								if(array_search($resource->license_id, $requiredLicenses) === false)
									$requiredLicenses[] = $resource->license_id;
							}
							else
							{
								if(array_search($resource->resource_license_id, $resourcesId) === false)
									$resourcesId[] = $resource->resource_license_id;
							}
							$allowAccess = false;
						}
					}
				}
			}
		}
	}
	
	function onAjaxCall($plugin, &$output)
	{
		if($plugin == "remository")
		{
			$x = JRequest::getInt('x', 0);
			$db =& JFactory::getDBO();
			$db->setQuery('SELECT id, filetitle as title FROM #__downloads_files WHERE containerid  =' . $x);
			$files = $db->loadObjectList();
			$output = '<<' . count($files);
			foreach($files as $file)
			{
				$output .= '>' . htmlspecialchars($file->id) . "<" . htmlspecialchars($file->title);
			}
			$output .= '>>';
		}
	}
	
	function getReturnPage($option, &$returnPage)
	{
		if($option == "com_remository")
		{
			$download = JRequest::getInt('id', 0);
			$returnPage = "index.php?option=com_remository&func=fileinfo&id=" . urlencode($download);
		}
	}
	
	/*
	Returns item id for current download
	*/
	function onGetItemId($option, &$itemId)
	{
		if($option == 'com_remository')
		{
			$itemId = JRequest::getInt('id', 0);
		}
	}
	
}
?>